/*************************************************
 sfc/snes hirom dump script
 
 cpu_read
 cpu_write
 ram_read
 ram_write
 
 20181108: FIXED SRAM DUMP SUPPORT 32K OR MORE
*************************************************/
function cpu_dump(d, rom_size, banksize)
{
	for(local i = 0; i < rom_size; i += 0x10000)
	{
		if(i<0x400000)
			cpu_read (d, 0xC00000+i, 0x10000); 
		else
			cpu_read (d, 0x000000+i, 0x10000); 
	}
}

function save_dump(d, save_size, max_size)
{
	for(local i = 0; i < save_size; i += 0x400)
	{
		ram_read (d, 0x306000+(i&0x1FFF)+((i/0x2000)*0x10000), 0x400); 
	}
}

function save_write(d, save_size, max_size)
{
	for(local i = 0; i < save_size; i += 0x200)
	{
		ram_write (d, 0x306000+(i&0x1FFF)+((i/0x2000)*0x10000), 0x200); 
	}
}