/*************************************************
 sfc/snes lorom dump script
 
 cpu_read
 cpu_write
 ram_read
 ram_write
 
 20190306 update sdd-1 support(Star Ocean.)
 
*************************************************/
function cpu_dump(d, rom_size, banksize)
{
	if(rom_size==0x600000)//48Mbit Star Ocean.
	{
		//first 16Mbit
		/*for(local i = 0; i < 0x200000*2; i += 0x10000)
		{
			cpu_read (d, 0x8000+i, 0x8000); 
		}*/
		//sdd-1
		for(local sdd_bank=0; sdd_bank <6; sdd_bank +=1)
		{
			cpu_write(d,0x4804,sdd_bank);
			for(local i = 0; i < 0x100000; i += 0x10000)
			{
				cpu_read (d, 0xC00000+i, 0x10000); 
			}
		}
	}
	else
	for(local i = 0; i < rom_size*2; i += 0x10000)
	{
	//enable second rom chip
	//only need for rockman x2
		if(i==0x200000)
			cpu_write(d,0x7F52,0x00,0x7F52,0x01);
		cpu_read (d, 0x8000+i, 0x8000); 
	}
}


function save_dump(d, save_size, max_size)
{
	for(local i = 0; i < save_size; i += 0x400)
	{
		ram_read (d, 0x710000+i, 0x400); 
	}
}


function save_write(d, save_size, max_size)
{
	for(local i = 0; i < save_size; i += 0x100)
	{
		ram_write (d, 0x710000+i, 0x100); 
	}
}